#Module with the commands to the equipment Válvula 02

package provide slm_02 0.0

puts "Carregado [info script]"

namespace eval slm_02	 {
    
    variable time_out 100 pin_number d9 serial_controller dfc transaction_id id
    
    #namespace export setPosition checkConnection
    
    proc setPosition { position } {
	
	variable serial_controller; variable transaction_id

	#Set the conversion table from position number to degree of giration to servo motor
	dict set position_v2 1 0
	dict set position_v2 2 45
	dict set position_v2 3 90

	set p [dict get $position_v2 $position]

	puts "slm_02 command setPosition position:$position"

	set rtn [$serial_controller sendCommand "setPosition;V2;$p;$transaction_id"]
	
        if { $rtn == "COMMAND_SENT" } {

	   return "ACK;setPosition;V2;$p;$transaction_id"

	} else {

	   return "NACK;$rtn"

        }
        
    }

    #serial_controller dataFlowController
    proc checkConnection { serial_controller transaction_id } {

         variable timeout; variable pin_number

         puts "Command checkConnection of slm_02 serial_controller: $serial_controller\n"

         $serial_controller sendCommand "checkConnection;$transaction_id"
	 
    }

    #serial_controller dataFlowController
    proc init { serial_controller transaction_id } {

         puts "Module slm_02 command init"

         #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

   }

    #serial_controller dataFlowController
    proc end_init { serial_controller transaction_id } {

         puts "Module slm_02 command end_init"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

   }

    #serial_controller dataFlowController
    proc error_init { serial_controller transaction_id } {

         puts "Module slm_02 command error_init"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

    }

   #serial_controller dataFlowController
   proc setup { serial_controller transaction_id } {

         puts "Module slm_02 command setup"

         #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

   }

    #serial_controller dataFlowController
    proc end_setup { serial_controller transaction_id } {

         puts "Module slm_02 command end_setup"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"
   }

    #serial_controller dataFlowController
    proc error_setup { serial_controller transaction_id } {

         puts "Module slm_02 command error_setup"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

   }

    proc setInternalArgs { s_c t_id } {

    	 variable serial_controller; variable transaction_id

	 puts "\nProcedure setInternalArgs $s_c and $t_id\n"

	 set serial_controller $s_c
	 set transaction_id $t_id

    }
}
